;;
(require "japanese.scm")
(require "generic-key.scm")
;;
(define prime-init-lib-ok? nil)
;; configs
(define prime-use-candidate-window? #t)
(define prime-candidate-op-count 1)

;; key defs
(define prime-on-key
  (lambda (key key-state)
    (or
     (and (= (to-lower-char key) 106)
	  (control-key-mask key-state))
     (generic-on-key key key-state))))
(define prime-off-key
  (lambda (key key-state)
    (= (to-lower-char key) 108)))
(define prime-begin-conv-key
  (lambda (key key-state)
    (= (to-lower-char key) 32)))
(define prime-commit-key
  (lambda (key key-state)
    (or
     (and (= (to-lower-char key) 106)
	  (control-key-mask key-state))
     (= key 'return))))
(define prime-extend-segment-key
  (lambda (key key-state)
    (or
     (and
      (control-key-mask key-state)
      (= (to-lower-char key) 111))
     (and
      (shift-key-mask key-state)
      (= key 'right)))))
(define prime-shrink-segment-key
  (lambda (key key-state)
    (or
     (and
      (control-key-mask key-state)
      (= (to-lower-char key) 105))
     (and
      (shift-key-mask key-state)
      (= key 'left)))))
(define prime-next-candidate-key
  (lambda (key key-state)
    (generic-next-candidate-key key key-state)))
(define prime-prev-candidate-key
  (lambda (key key-state)
    (generic-prev-candidate-key key key-state)))
(define prime-cancel-key
  (lambda (key key-state)
    (generic-cancel-key key key-state)))
(define prime-backspace-key
  (lambda (key key-state)
    (generic-backspace-key key key-state)))
(define prime-delete-key
  (lambda (key key-state)
    (generic-delete-key key key-state)))
(define prime-go-left-key
  (lambda (key key-state)
    (generic-go-left-key key key-state)))
(define prime-go-right-key
  (lambda (key key-state)
    (generic-go-right-key key key-state)))
(define prime-next-segment-key
  (lambda (key key-state)
    (generic-go-right-key key key-state)))
(define prime-prev-segment-key
  (lambda (key key-state)
    (generic-go-left-key key key-state)))

;; access
(define prime-context-on
  (lambda (ac)
    (car (nthcdr 0 ac))))

(define prime-context-set-on!
  (lambda (ac s)
    (set-car! (nthcdr 0 ac) s)))

(define prime-context-state
  (lambda (ac)
    (car (nthcdr 1 ac))))

(define prime-context-set-state!
 (lambda (ac st)
   (set-car! (nthcdr 1 ac) st)))

(define prime-context-ac-id
  (lambda (ac)
    (car (nthcdr 2 ac))))

(define prime-context-set-ac-id!
  (lambda (ac id)
    (set-car! (nthcdr 2 ac) id)))

(define prime-context-left-string
 (lambda (ac)
   (car (nthcdr 3 ac))))

(define prime-context-set-left-string!
  (lambda (ac str)
    (set-car! (nthcdr 3 ac) str)))

(define prime-context-right-string
 (lambda (ac)
   (car (nthcdr 4 ac))))

(define prime-context-set-right-string!
  (lambda (ac str)
    (set-car! (nthcdr 4 ac) str)))

(define prime-context-rkc
  (lambda (ac)
    (car (nthcdr 5 ac))))

(define prime-context-set-rkc!
 (lambda (ac rkc)
   (set-car! (nthcdr 5 ac) rkc)))

(define prime-context-index-list
  (lambda (ac)
    (car (nthcdr 6 ac))))
  
(define prime-context-set-index-list!
 (lambda (ac lst)
   (set-car! (nthcdr 6 ac) lst)))

(define prime-context-cur-seg
  (lambda (ac)
    (car (nthcdr 7 ac))))

(define prime-context-set-cur-seg!
  (lambda (ac seg)
    (set-car! (nthcdr 7 ac) seg)))

(define prime-context-candidate-window
  (lambda (ac)
    (car (nthcdr 8 ac))))

(define prime-context-set-candidate-window!
  (lambda (ac f)
    (set-car! (nthcdr 8 ac) f)))

(define prime-context-candidate-op-count
  (lambda (ac)
    (car (nthcdr 9 ac))))

(define prime-context-set-candidate-op-count!
  (lambda (ac c)
    (set-car! (nthcdr 9 ac) c)))
;; on/off state(compose,input) prime-context-id string rkc index-list
;; cur-seg candidate-window
(define prime-context-new
 (lambda ()
   (let ((c '())
	 (rkc (rk-context-new jp-rk-rule #t #f)))
     (set! c (copy-list '(() () () () () () () () () () ())))
     (prime-context-set-ac-id!
      c
      (if prime-init-lib-ok?
	  (prime-lib-alloc-context)
	  ()))
     (prime-context-set-rkc! c rkc)
     (prime-flush c)
     (prime-context-set-on! c #f)
     c)))

(define prime-make-string
  (lambda (sl dir)
    (if sl
	(if dir
	    (string-append (prime-make-string (cdr sl) dir)
			   (caar sl))
	    (string-append (caar sl)
			   (prime-make-string (cdr sl) dir)))
	"")))

(define prime-get-candidate
  (lambda (ac nth-seg)
    (let ((id (prime-context-ac-id ac))
	  (idx (nth (prime-context-index-list ac) nth-seg)))
      ())))

(define prime-init-handler
  (lambda (id arg)
    (let ((c (find-context id)))
      (set-context-data! c
			 (prime-context-new))
      (im-clear-mode-list id)
      (im-pushback-mode-list id "RAW")
      (im-pushback-mode-list id "Ҥ餬")
      (im-update-mode-list id)
      (im-update-mode id 0)
      ())))

(define prime-release-handler
  (lambda (id)
    (let* ((c (find-context id))
	   (ac (context-data c))
	   (ac-id (prime-context-ac-id ac)))
      (prime-lib-free-context ac-id))))

(define prime-mode-handler
  (lambda (id mode)
    (let* ((c (find-context id))
	   (ac (context-data c)))
      (prime-flush ac)
      (if (= mode 0)
	  (prime-context-set-on! ac '())
	  (prime-context-set-on! ac #t))
      (prime-update-preedit ac id))
    ()))

(define prime-flush
  (lambda (ac)
    (rk-flush (prime-context-rkc ac))
    (prime-context-set-left-string! ac '())
    (prime-context-set-right-string! ac '())
    (prime-context-set-on! ac #t)
    (prime-context-set-state! ac #f)
    (prime-context-set-index-list! ac ())
    (prime-context-set-candidate-window! ac #f)
    (prime-context-set-candidate-op-count! ac 0)))

(define prime-begin-input
  (lambda (ac)
    (prime-context-set-on! ac #t)
    (rk-flush (prime-context-rkc ac))
    (prime-context-set-state! ac #f)))

(define prime-update-preedit
  (lambda (ac id)
    (if (prime-context-on ac)
	(if (prime-context-state ac)
	    (prime-compose-state-preedit ac id)
	    (prime-input-state-preedit ac id))
	(begin
	  (im-clear-preedit id)
	  (im-update-preedit id)))))

(define prime-proc-raw-state
  (lambda (c key key-state)
    (let ((id (context-id c))
	  (ac (context-data c)))
      (if (prime-on-key key key-state)
	  (begin
	    (prime-begin-input ac)
	    (im-update-mode id 1))
	  (im-commit-raw (context-id c))))))

(define prime-make-index-list-rec
  (lambda (n)
    (if (> n 0)
	(cons 0
	      (prime-make-index-list-rec (- n 1)))
	'())))

(define prime-make-index-list
  (lambda (n old-lst)
    (if (< n (length old-lst))
	(truncate-list old-lst n 1)
	(append old-lst
		(prime-make-index-list-rec (- n
					      (length old-lst)))))))

(define prime-begin-conv
  (lambda (ac)
    (let ((ac-id (prime-context-ac-id ac)))
      (prime-context-set-index-list!
       ac
       (prime-make-index-list
	(prime-lib-get-nr-segments ac-id)
	nil))
      (prime-context-set-state! ac #t)
      (prime-context-set-cur-seg! ac 0)
      (rk-flush (prime-context-rkc ac)))))

(define prime-proc-input-state-no-preedit
  (lambda (ac id key key-state)
    (let
	((rkc (prime-context-rkc ac))
	 (direct (jp-direct (charcode->string key))))
      (and
       (if (prime-off-key key key-state)
	   (begin
	     (prime-flush ac)
	     (prime-context-set-on! ac #f)
	     (im-update-mode id 0)
	     #f)
	   #t)
       (if (prime-backspace-key key key-state)
	   (begin
	     (im-commit-raw id)
	     #f)
	   #t)
       (if (prime-delete-key key key-state)
	   (begin
	     (im-commit-raw id)
	     #f)
	   #t)
       ;; modifiers (except shift) => ignore
       (if (and (modifier-key-mask key-state)
		(not (shift-key-mask key-state)))
	   (begin
	     (im-commit-raw id)
	     #f)
	   #t)
       ;; direct key => commit
       (if direct
	   (begin
	     (im-commit id direct)
	     #f)
	   #t)
       (set! key-str (charcode->string (to-lower-char key)))
       (if (string-find (rk-expect rkc) key-str)
	   (let ((res))
	     (set! res (rk-push-key! rkc key-str))
	     (if res
		 (prime-context-set-left-string!
		  ac
		  (cons res (prime-context-left-string ac))))
	     #f)
	   #t)
       (im-commit-raw id)))))

(define prime-has-preedit?
  (lambda (ac)
    (or
     (> (length (prime-context-left-string ac)) 0)
     (> (length (prime-context-right-string ac)) 0)
     (> (length (rk-pending (prime-context-rkc ac))) 0))))

(define prime-proc-input-state-with-preedit
  (lambda (ac id key key-state)
    (let ((rkc (prime-context-rkc ac)))
      (and
       ;; begin conversion
       (if (and
	    (prime-begin-conv-key key key-state)
	    prime-init-lib-ok?)
	   (begin
	     (prime-begin-conv ac)
	     #f)
	   #t)
       ;; backspace
       (if (prime-backspace-key key key-state)
	   (begin
	     (if (not (rk-backspace rkc))
		 (if (prime-context-left-string ac)
		     (prime-context-set-left-string!
		      ac
		      (cdr (prime-context-left-string ac)))))
	     #f)
	   #t)
       ;; delete
       (if (prime-delete-key key key-state)
	   (begin
	     (if (not (rk-delete rkc))
		 (if (prime-context-right-string ac)
		     (prime-context-set-right-string!
		      ac
		      (cdr (prime-context-right-string ac)))))
	     #f)
	   #t)
       ;; cancel
       (if (prime-cancel-key key key-state)
	   (begin
	     (prime-flush ac)
	     #f)
	   #t)
       ;;
       (if (prime-commit-key key key-state)
	   (begin
	     (im-commit
	      id
	      (string-append
	       (prime-make-string (prime-context-left-string ac) #t)
	       (prime-make-string (prime-context-right-string ac) #f)))
	     (prime-flush ac)
	     #f)
	   #t)
       ;; left
       (if (prime-go-left-key key key-state)
	   (begin
	     (if (prime-context-left-string ac)
		 (let
		     ((c (car (prime-context-left-string ac))))
		   (prime-context-set-left-string!
		    ac (cdr (prime-context-left-string ac)))
		   (prime-context-set-right-string! ac
						    (cons c
							  (prime-context-right-string ac)))))
	     #f)
	   #t)
       ;; right
       (if (prime-go-right-key key key-state)
	   (begin
	     (if (prime-context-right-string ac)
		 (let
		     ((c (car (prime-context-right-string ac))))
		   (prime-context-set-right-string!
		    ac (cdr (prime-context-right-string ac)))
		   (prime-context-set-left-string! ac
						   (cons c
							 (prime-context-left-string ac)))))
	     #f)
	   #t)
       ;; modifiers (except shift) => ignore
       (if (and (modifier-key-mask key-state)
		(not (shift-key-mask key-state)))
	   (begin
	     (im-commit-raw id)
	     #f)
	   #t)
       (set! key (to-lower-char key))
       (let ((res)
	     (key-str (charcode->string key)))
	 (set! res (rk-push-key! rkc key-str))
	 (if res
	     (begin
	     (prime-context-set-left-string!
	      ac
	      (cons res (prime-context-left-string ac)))
	     #t))
	 (prime-lib-get-candidate-list (anthy-make-string (anthy-context-left-string ac) #t) "")
	 )))))


(define prime-proc-input-state
  (lambda (ac id key key-state)
    (if (prime-has-preedit? ac)
	(prime-proc-input-state-with-preedit ac id key key-state)
	(prime-proc-input-state-no-preedit ac id key key-state))))

(define prime-pushback-preedit-segment-rec
  (lambda (ac id idx nseg)
    (let ((ac-id (prime-context-ac-id ac)))
      (if (< idx nseg)
	  (begin
	    (im-pushback-preedit
	     id
	     (if (= idx (prime-context-cur-seg ac))
		 (+ preedit-reverse preedit-cursor)
		 preedit-underline)
	     (prime-lib-get-nth-candidate
	      ac-id idx
	      (nth idx (prime-context-index-list ac))))
	    (prime-pushback-preedit-segment-rec ac id (+ idx 1) nseg))))))

(define prime-compose-state-preedit
  (lambda (ac id)
    (im-clear-preedit id)
    (prime-pushback-preedit-segment-rec
     ac id
     0 (length (prime-context-index-list ac)))
    (im-update-preedit id)))

(define prime-input-state-preedit
  (lambda (ac id)
    (let ((rkc (prime-context-rkc ac)))
      (im-clear-preedit id)
      (im-pushback-preedit
       id preedit-underline
       (prime-make-string (prime-context-left-string ac) #t))
      (im-pushback-preedit id preedit-underline
                           (rk-pending rkc))
      (if (prime-has-preedit? ac)
	  (im-pushback-preedit id preedit-cursor ""))
      (im-pushback-preedit
       id preedit-underline
       (prime-make-string (prime-context-right-string ac) #f))
      (im-update-preedit id))))

(define prime-get-commit-string
  (lambda (ac idx nseg)
    (let ((ac-id (prime-context-ac-id ac)))
      (if (< idx nseg)
	  (string-append
	   (prime-lib-get-nth-candidate
	    ac-id idx
	    (nth idx (prime-context-index-list ac)))
	   (prime-get-commit-string ac (+ idx 1) nseg))
	  ""))))

(define prime-do-commit
  (lambda (ac id)
    (prime-reset-candidate-window ac id)
    (im-commit id
	       (prime-get-commit-string
		ac 0
		(length (prime-context-index-list ac))))
    (prime-commit-string
     ac 0
     (length (prime-context-index-list ac)))
    (prime-flush ac)))

(define prime-commit-string
  (lambda (ac idx nseg)
    (let ((ac-id (prime-context-ac-id ac)))
      (if (< idx nseg)
	  (begin
	    (prime-lib-commit-segment
	     ac-id idx (nth idx (prime-context-index-list ac)))
	    (prime-commit-string ac
				 (+ idx 1) nseg))
	  nil))))

(define prime-move-segment
  (lambda (ac dir)
    (let ((pos (+ (prime-context-cur-seg ac) dir))
	  (nseg (length  (prime-context-index-list ac))))
      (if (and
	   (> pos -1)
	   (< pos nseg))
	  (prime-context-set-cur-seg! ac pos)))))

(define prime-move-candidate
  (lambda (ac id off)
    (let* ((seg (prime-context-cur-seg ac))
	   (n (nth seg (prime-context-index-list ac)))
	   (ac-id (prime-context-ac-id ac))
	   (max (prime-lib-get-nr-candidates ac-id seg)))
      (set! n (+ n off))
      (if (>= n max)
	  (set! n 0))
      (if (< n 0)
	  (set! n (- max 1)))
      (set-car! (nthcdr seg (prime-context-index-list ac)) n)
      (prime-context-set-candidate-op-count!
       ac
       (+ 1 (prime-context-candidate-op-count ac)))
      (if (and
	   (= (prime-context-candidate-op-count ac)
	      prime-candidate-op-count)
	   prime-use-candidate-window?)
	  (begin
	    (prime-context-set-candidate-window! ac #t)
	    (im-begin-candidate
	     id
	     max 0)))
      (if (prime-context-candidate-window ac)
	  (im-update-candidate id n)))))

(define prime-reset-candidate-window
  (lambda (ac id)
    (if (prime-context-candidate-window ac)
	(begin
	  (im-end-candidate id ac)
	  (prime-context-set-candidate-window! ac #f)))
    (prime-context-set-candidate-op-count! ac 0)))


(define prime-proc-compose-state
  (lambda (ac id key key-state)
    (and
     (if (prime-commit-key key key-state)
	 (begin
	   (prime-do-commit ac id)
	   #f)
	 #t)
     (if (prime-backspace-key key key-state)
	 (begin
	   (prime-context-set-state! ac #f)
	   (prime-reset-candidate-window ac id)
	   #f)
	 #t)
     (if (prime-next-candidate-key key key-state)
	 (begin
	   (prime-move-candidate ac id 1)
	   #f)
	 #t)
     (if (prime-prev-candidate-key key key-state)
	 (begin
	   (prime-move-candidate ac id -1)
	   #f)
	 #t)
     (if (prime-cancel-key key key-state)
	 (begin
	   (prime-context-set-state! ac #f)
	   (prime-reset-candidate-window ac id)
	   #f)
	 #t)
     (if (modifier-key-mask key-state)
	 #f
	 #t)
     (begin
       (prime-do-commit ac id)
       (prime-proc-input-state ac id key key-state)))
    ()))

(define prime-press-key-handler
  (lambda (id key key-state)
    (let* ((c (find-context id))
	   (ac (context-data c)))
      (if (prime-context-on ac)
	  (if (prime-context-state ac)
	      (prime-proc-compose-state ac id key key-state)
	      (prime-proc-input-state ac id key key-state))
	  (prime-proc-raw-state c key key-state))
      ;; preedit
      (prime-update-preedit ac id))))


(define prime-release-key-handler
  (lambda (id key key-state)
    ()))

(define prime-reset-handler
  (lambda (id)
    ()))

(if (and
     (symbol-bound? 'prime-lib-init)
     (prime-lib-init))
    (set! prime-init-lib-ok? #t))

(define prime-get-candidate-handler
  (lambda (id idx)
    (let* ((c (find-context id))
	   (ac (context-data c))
	   (ac-id (prime-context-ac-id ac)))
      (prime-lib-get-nth-candidate
       ac-id (prime-context-cur-seg ac)
       idx))))

(define prime-set-candidate-index-handler
  (lambda (id idx)
    (let* ((c (find-context id))
	   (ac (context-data c))
	   (seg (prime-context-cur-seg ac))
	   (ac-id (prime-context-ac-id ac)))
      (set-car! (nthcdr seg (prime-context-index-list ac)) idx)
      (prime-update-preedit ac id))))

(register-im
 'prime
 "ja"
 "EUC-JP"
 nil
 prime-init-handler
 prime-release-handler
 prime-mode-handler
 prime-press-key-handler
 prime-release-key-handler
 prime-reset-handler
 prime-get-candidate-handler
 prime-set-candidate-index-handler)

;(prime-lib-send-command "l\ttok\n")
